/*
 *
 *  Singe 2
 *  Copyright (C) 2006-2020 Scott Duensing <scott@kangaroopunch.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */


#ifndef UTIL_H
#define UTIL_H


#include <stdio.h>
#include <stdarg.h>
#include <sys/stat.h>


#include "common.h"


#define UTIL_PATH_MAX  1024


extern FILE *utilTraceFile;


char *utilCreateString(char *format, ...);
char *utilCreateStringVArgs(char *format, va_list args);
void  utilDie(char *fmt, ...);
bool  utilFileExists(char *filename);
void  utilFixPathSeparators(char **path, bool slash);
char *utilGetFileExtension(char *filename);
char *utilGetLastPathComponent(char *pathname);
char  utilGetPathSeparator(void);
bool  utilMkDirP(const char *dir, const mode_t mode);
bool  utilPathExists(char *pathname);
char *utilReadFile(char *filename, size_t *bytes);
char *utilReadLine(char *haystack, size_t length, char **offset);
void  utilRedirectConsole(void);
void  utilSay(char *fmt, ...);
int   utilStricmp(char *a, char *b);
char *utilStrndup( const char *s1, size_t n);
void  utilTrace(char *fmt, ...);
void  utilTraceEnd(void);
void  utilTraceStart(char *filename);
void  utilTraceVArgs(char *fmt, va_list args);

#endif // UTIL_H
